#ifndef DEBUG_INCLUDE_H
#define DEBUG_INCLUDE_H

#include <genesis.h>
#include <vdp_spr.h>

#include "Config.h"
#include "ObjectStruct.h"

// Prints value with KDebug_Alert
void PrintNumber(u32 value);
void Print(char* message);
void PrintSprite(const SpriteDef* sprite);
void PrintType(u16 objectType);
void PrintObject(ObjectStruct* object);
void PrintObjectStruct(ObjectStruct* object);

// Prints value on the APLAN
void PrintAPLAN(u32 value, u16 x, u16 y);
void PrintWPLAN(u32 value, u16 x, u16 y);

void ErrorMessage(const char* message);
void Assert(u16 condition, const char* message);

#endif
