#include "DrawManager.h"

#include <genesis.h>
#include <KDebug.h>
#include "ObjectStruct.h"
#include "vdp_spr.h"
#include "VDP_Extra.h"
#include "PlayerManager.h"
#include "exported/ExportedGGAnimations.h"
#include "exported/ExportedGenResSprites.h"
#include "HUDManager.h"
#include "generated\DebugSettings.h"

extern ObjectStruct* firstObjectOfType[MAX_OBJECT_TYPES];

extern u16 spriteNum;

void DrawObjects(u16 objectType)
{
    if (*(firstObjectOfType + objectType)== NULL) return;

    ObjectStruct* object = *(firstObjectOfType + objectType);

    while (object != NULL)
    {
        object->drawFunction(object);
        object = (ObjectStruct*)object->nextObjectOfSameType;
    }
}

void DrawManager_Draw()
{
    MyVDP_resetSprites();

    HUDManager_Draw();

    DrawObjects(TYPE_PICKUP);
    DrawObjects(TYPE_EFFECT);
    DrawObjects(TYPE_PLAYER_BULLET);
    DrawObjects(TYPE_PLAYER_PROJECTILE);
    DrawObjects(TYPE_ENEMY_PROJECTILE);
    DrawObjects(TYPE_GRABBER);

    PlayerManager_DrawPlayer();

    DrawObjects(TYPE_ENEMY);

    DrawObjects(TYPE_BACKGROUNDOBJECT);

    MyVDP_setLastSprite();
}


