#ifndef GRAPHICSGALE_ANIMATION_TYPES_HEADER_H
#define GRAPHICSGALE_ANIMATION_TYPES_HEADER_H

#include <genesis.h>
#include "VDPInfo.h"

typedef struct
{
    u32 const* spriteData;
    u16 xoffset;
    u16 xflippedoffset;
    u16 yoffset;
    u16 VDPTileOffset;
    u16 sgdkSpriteSize;
} GGSprite;

typedef struct GGFrame
{
    const GGSprite* const* sprites;
    u16 numSprites;
    u16 frameDelayTime;
    const struct GGFrame* nextFrame;
} GGFrame;

typedef struct
{
    const GGFrame* const* frames;   // pointer to animation frames
    u16 numberOfFrames;             // number of frames
    u16 width;                      // width of the total area of the sprite in pixels
    u16 height;                     // height of the total area of the sprite in pixels
    u16 maxNumberOfTilesPerFrame;   // the number of tiles required to store one frame
    u16 totalTiles;                 // the total number of tiles in the animation
    u32 const* allSpriteData;       // start of the sprite data
    const VDPInfo*  vdpInfo;        // the runtime vdpinfo
} GGAnimation;



#define DIRECTION_LEFT  1
#define DIRECTION_RIGHT 0

#endif
