#include "JoypadManager.h"

#define TAP_HOLD_THRESHOLD 8

u16 joystate;
u16 oldjoystate;
JoystickStateStruct joystickState;

void JoypadManager_Init()
{
    oldjoystate = 0;
}

void JoypadManager_ResetJoypad()
{
    joystickState.startPressed = 0;
    joystickState.aPressed = 0;
    joystickState.bPressed = 0;
    joystickState.cPressed = 0;
    joystickState.leftPressed = 0;
    joystickState.rightPressed = 0;
    joystickState.upPressed = 0;
    joystickState.downPressed = 0;
}

void JoypadManager_UpdateJoypad()
{
    joystate = JOY_readJoypad(JOY_1);

    joystickState.startPressed = (joystate & BUTTON_START) && !(oldjoystate & BUTTON_START);
    joystickState.aPressed = (joystate & BUTTON_A) && !(oldjoystate & BUTTON_A);
    joystickState.bPressed = (joystate & BUTTON_B) && !(oldjoystate & BUTTON_B);
    joystickState.cPressed = (joystate & BUTTON_C) && !(oldjoystate & BUTTON_C);

    joystickState.leftPressed = (joystate & BUTTON_LEFT) && !(oldjoystate & BUTTON_LEFT);
    joystickState.rightPressed = (joystate & BUTTON_RIGHT) && !(oldjoystate & BUTTON_RIGHT);

    joystickState.upPressed = (joystate & BUTTON_UP) && !(oldjoystate & BUTTON_UP);
    joystickState.downPressed = (joystate & BUTTON_DOWN) && !(oldjoystate & BUTTON_DOWN);

    oldjoystate = joystate;
}

