#ifndef OBJECT_MANAGER_INCLUDE_H
#define OBJECT_MANAGER_INCLUDE_H

#include <genesis.h>
//#include <vdp_spr.h>

#include "ObjectStruct.h"

void ObjectManager_Init();
void ObjectManager_ResetObjectCollections();
void ObjectManager_ResetEnemyProjectileCollection();
void ObjectManager_UpdateObjects();
void ObjectManager_EraseAllObjectsOfType(u16 type);

void ObjectManager_ClearPendingObjects();

ObjectStruct* ObjectManager_CreateObject(u16                          objectType, 
                                         ObjectFunctionType           updateFunction, 
                                         ObjectFunctionType           drawFunction, 
                                         ObjectCollisionFunctionType  collisionFunction,
                                         ObjectCollisionFunctionType  grabbedFunction);

void ObjectManager_SwitchType(ObjectStruct* object, u16 toType);

void ObjectManager_DestroyObject(ObjectStruct* object);

#endif
