#include "ObjectStreamer.h"

#include "Config.h"
#include "Debug.h"
#include "LevelManager.h"
#include "MathUtils.h"
#include "ScrollManager.h"

#include <KDebug.h>


void PrintSpawns();

const SpawnStruct* nextSpawn = NULL;

void ObjectStreamer_Init()
{
    nextSpawn = &currentForegroundMap->spawnList[0];

    //PrintSpawns();
}

extern s16 backgroundScroll;

void ObjectStreamer_Update()
{
    s16 scrollPosition = backgroundScroll + P2V(SCREEN_WIDTH);

    while (nextSpawn != NULL &&
           nextSpawn->x < scrollPosition)
    {
        if (nextSpawn->createObject != NULL)
        {
            nextSpawn->createObject(nextSpawn->x, nextSpawn->y, nextSpawn->properties, nextSpawn->numProperties);
            nextSpawn++;
        }
        else
        {
            nextSpawn = NULL;
        }        
    }
}

void PrintSpawns()
{
    int loop = currentForegroundMap->numSpawns;

    const SpawnStruct* spawnStruct = &currentForegroundMap->spawnList[0];


    while (loop--)
    {
        Print("----");
        PrintNumber((u32)spawnStruct->createObject);
        PrintNumber(spawnStruct->x);
        PrintNumber(spawnStruct->y);
        PrintNumber((u32)spawnStruct->properties);
        PrintNumber(spawnStruct->numProperties);
        spawnStruct++;
    }

}

