#ifndef PLAYER_INCLUDE_H
#define PLAYER_INCLUDE_H

#include "ObjectStruct.h"
#include "VDPInfo.h"

#define PLAYER_PIXEL_HEIGHT 40



// player states
#define PLAYERSTATE_ENTERING            0
#define PLAYERSTATE_FLYING              1
#define PLAYERSTATE_DYING               2

typedef struct
{
    u16 playerState;
    s16 playerLevelStartX;
    s16 playerLevelStartY;
    s16 oldPositionX;
    s16 oldPositionY;
    u16 lives;
    u16 freezeTimer;
    void (*onfreezeTimerDone)();
    u16 invincibilityTimer;
    u16 startingLifeTimer;
    u16 onGround;
    u16 disablePlayer;
    ObjectStruct* platform;
} PlayerDataStruct;

extern s16 flyingOffsetY;
extern s16 backgroundScrollSpeed;
extern s16 backgroundScroll;
extern s16 oldBackgroundScroll;
extern ObjectStruct* playerObject;
extern PlayerDataStruct playerData;
extern ObjectStruct* grabbedObject;

// setup at various times.
void PlayerManager_SetupForGame();
void PlayerManager_SetupForLevel();
void PlayerManager_SetupLife();
void PlayerManager_InitPosition(s16 x, s16 y);

void PlayerManager_UpdatePlayer();
void PlayerManager_DrawPlayer();
void PlayerManager_CollideWithPlayer(ObjectStruct* collidedObject);

// scripting helper functions.
void PlayerManager_StartAutomatedWalkLeft();
void PlayerManager_StartAutomatedWalkRight();
void PlayerManager_StartAutomatedFall();
void PlayerManager_ReturnControlStartIdle();
void PlayerManager_ReturnControlStartFall();

#endif
