#ifndef VDP_MANAGER_INCLUDE_H
#define VDP_MANAGER_INCLUDE_H

#include <genesis.h>
#include <genres.h>

#include "GGAnimationDraw.h"
#include "VDPInfo.h"

extern u16 fontTileIndex;

#define LOAD_GENRES_SPRITE_TO_VDP(spritename) VDPManager_LoadSpriteDataToVDP(&spritename##Sprite, &spritename##VDPInfo);
#define LOAD_GGANIMATION_TO_VDP(animationname) VDPManager_LoadGGAnimationToVDP(&animationname, &animationname##VDPInfo);

// Genres Resources
#define IMPORT_GENRES_SPRITE(spritename) extern struct genresSprites spritename##Sprite; \
                                         extern VDPInfo spritename##VDPInfo;

#define VDPINFO(spritename) VDPInfo spritename##VDPInfo;

void VDPManager_ResetVDPInfo();
void VDPManager_ResetDisplay();
void VDPManager_ReserveVDPArea(VDPInfo* vdpInfo, u16 numTiles);

void VDPManager_LoadSpriteDataToVDP(const struct genresSprites* sprite, VDPInfo* spriteVDPInfo);

void VDPManager_LoadGGAnimationToVDP(const GGAnimation* animation, VDPInfo* animationVDPInfo);
void VDPManager_CopyGGAnimationFrameToVDP(const GGAnimation* animation, u16 frameNumber, const VDPInfo* vdpInfo);

u16 VDPManager_loadFont(const u32 *font, u16 length);

#endif
