#ifndef VDP_EXTRA_INCLUDE
#define VDP_EXTRA_INCLUDE

#include <genesis.h>

// Helper functions or slightly different versions of the standard SGDK functions.

#define GET_DIRECTION(tileInfo) (tileInfo & TILE_ATTR_HFLIP_MASK)

void MyVDP_setTileMapRect(u16 plan, const u16 *data, u16 basetile, u16 x, u16 y, u16 w, u16 h);
void VDP_setAllHorizontalScrollLines(u16 plan, u16 value);
void VDP_setHorizontalScrollLines(u16 plan, u16* lines);


void MyVDP_setHorizontalScrollTile(u16 plan, u16 tile, s16* values, u16 len, u16 use_dma);

void VDP_setAllHorizontalScrollTiles(u16 plan, s16 value);

void MyVDP_doDMA(u8 location, u32 from, u16 to, u16 len, u16 autoInc);
void MyVDP_doVRamDMACopy(u16 from, u16 to, u16 len, u16 autoInc);
void MyVDP_waitVSync();

void MyVDP_drawText(const char *str, u16 x, u16 y);

extern SpriteDef* currentSpriteDef;
extern u8 spriteDrawIndex;

#define MyVDP_resetSprites()\
    currentSpriteDef = vdpSpriteCache;\
    spriteDrawIndex = 0;


#define MyVDP_setSprite(_x, _y, _size, _tile_attr) \
    if (spriteDrawIndex < MAX_SPRITE) \
    {\
        currentSpriteDef->posx = _x;\
        currentSpriteDef->posy = _y;\
        currentSpriteDef->tile_attr = (u16)_tile_attr;\
        currentSpriteDef->size = (u8)_size;\
        spriteDrawIndex++;\
        currentSpriteDef->link  = spriteDrawIndex;\
        currentSpriteDef++;\
    }


// if you're simply copying a spritedef, then use this.
// memcopies everything except the link because we're setting it manually.
#define MyVDP_setSpriteDef(_spriteDef) \
    if (spriteDrawIndex < MAX_SPRITE) \
    {\
        memcpy(currentSpriteDef, &_spriteDef, sizeof(SpriteDef) - 1);\
        spriteDrawIndex++;\
        currentSpriteDef->link  = spriteDrawIndex;\
        currentSpriteDef++;\
    }


#define MyVDP_setLastSprite() \
    if (spriteDrawIndex < MAX_SPRITE)\
    {\
        currentSpriteDef->posx = -0x80;\
        currentSpriteDef->link  = 0;\
    }\
    spriteNum = spriteDrawIndex + 1;

#endif
