#include "WeaponManager.h"

#include "exported\ExportedGenResSprites.h"
#include "exported\ExportedGGAnimations.h"
#include "generated\AllObjects.h"
#include "MathUtils.h"
#include "PlayerManager.h"

#define BULLET_SPEED 24

#define WEAPON_LEVEL_MAX 3

u16 weaponLevel[NUM_WEAPONS];
u16 currentWeapon = WEAPON_SHOT;
u16 oldWeapon = NUM_WEAPONS;
u16 numStars[NUM_WEAPONS];

void weaponFireStub() {}

typedef void (*weaponFireFunction)(void);

const u16* weaponPalettes[4];

void YellowWandFireLevel1()
{
    YellowWandBulletCreate(playerObject->x + P2V(36), 
                           playerObject->y + P2V(10) + P2V(flyingOffsetY), 
                           BULLET_SPEED,
                           0,
                           1, 
                           &YellowWandBulletLevel1, 
                           18,
                           5);

    weaponFireCooldownTimer = FIRE_COOLDOWN_TIME;

}

void YellowWandFireLevel2()
{
    YellowWandBulletCreate(playerObject->x + P2V(36), 
                           playerObject->y + P2V(10) + P2V(flyingOffsetY), 
                           BULLET_SPEED,
                           0,
                           2, 
                           &YellowWandBulletLevel2,
                           18,
                           10);

    weaponFireCooldownTimer = FIRE_COOLDOWN_TIME;
}

void YellowWandFireLevel3()
{
    YellowWandBulletCreate(playerObject->x + P2V(36), 
                           playerObject->y + P2V(10) + P2V(flyingOffsetY), 
                           BULLET_SPEED,
                           0,
                           4, 
                           &YellowWandBulletLevel3,
                           18,
                           20);

    weaponFireCooldownTimer = FIRE_COOLDOWN_TIME;
}

void RedWandFireLevel1()
{
    YellowWandBulletCreate(playerObject->x + P2V(36), 
                           playerObject->y + P2V(10) + P2V(flyingOffsetY), 
                           BULLET_SPEED,
                           0,
                           1, 
                           &RedWandBullet, 
                           8,
                           8);

    YellowWandBulletCreate(playerObject->x + P2V(36), 
                           playerObject->y + P2V(10) + P2V(flyingOffsetY), 
                           BULLET_SPEED,
                           BULLET_SPEED >> 1,
                           1, 
                           &RedWandBullet, 
                           8,
                           8);

    YellowWandBulletCreate(playerObject->x + P2V(36), 
                           playerObject->y + P2V(10) + P2V(flyingOffsetY), 
                           BULLET_SPEED,
                           -(BULLET_SPEED >> 1),
                           1, 
                           &RedWandBullet, 
                           8,
                           8);

    weaponFireCooldownTimer = FIRE_COOLDOWN_TIME;

}

void RedWandFireLevel2()
{
    YellowWandBulletCreate(playerObject->x + P2V(36), 
                           playerObject->y + P2V(10) + P2V(flyingOffsetY), 
                           BULLET_SPEED,
                           0,
                           1, 
                           &RedWandBullet, 
                           8,
                           8);

    YellowWandBulletCreate(playerObject->x + P2V(36), 
                           playerObject->y + P2V(10) + P2V(flyingOffsetY), 
                           BULLET_SPEED,
                           BULLET_SPEED >> 1,
                           1, 
                           &RedWandBullet, 
                           8,
                           8);

    YellowWandBulletCreate(playerObject->x + P2V(36), 
                           playerObject->y + P2V(10) + P2V(flyingOffsetY), 
                           BULLET_SPEED,
                           -(BULLET_SPEED >> 1),
                           1, 
                           &RedWandBullet, 
                           8,
                           8);

    YellowWandBulletCreate(playerObject->x + P2V(36), 
                           playerObject->y + P2V(10) + P2V(flyingOffsetY), 
                           BULLET_SPEED,
                           BULLET_SPEED >> 2,
                           1, 
                           &RedWandBullet, 
                           8,
                           8);

    YellowWandBulletCreate(playerObject->x + P2V(36), 
                           playerObject->y + P2V(10) + P2V(flyingOffsetY), 
                           BULLET_SPEED,
                           -(BULLET_SPEED >> 2),
                           1, 
                           &RedWandBullet, 
                           8,
                           8);


    weaponFireCooldownTimer = FIRE_COOLDOWN_TIME;

}

void RedWandFireLevel3()
{
    YellowWandBulletCreate(playerObject->x + P2V(36), 
                           playerObject->y + P2V(10) + P2V(flyingOffsetY), 
                           BULLET_SPEED,
                           0,
                           1, 
                           &RedWandBulletLarge, 
                           15,
                           15);

    YellowWandBulletCreate(playerObject->x + P2V(36), 
                           playerObject->y + P2V(10) + P2V(flyingOffsetY), 
                           BULLET_SPEED,
                           BULLET_SPEED >> 1,
                           1, 
                           &RedWandBulletLarge, 
                           15,
                           15);

    YellowWandBulletCreate(playerObject->x + P2V(36), 
                           playerObject->y + P2V(10) + P2V(flyingOffsetY), 
                           BULLET_SPEED,
                           -(BULLET_SPEED >> 1),
                           1, 
                           &RedWandBulletLarge, 
                           15,
                           15);

    YellowWandBulletCreate(playerObject->x + P2V(36), 
                           playerObject->y + P2V(10) + P2V(flyingOffsetY), 
                           BULLET_SPEED,
                           BULLET_SPEED >> 2,
                           1, 
                           &RedWandBulletLarge, 
                           15,
                           15);

    YellowWandBulletCreate(playerObject->x + P2V(36), 
                           playerObject->y + P2V(10) + P2V(flyingOffsetY), 
                           BULLET_SPEED,
                           -(BULLET_SPEED >> 2),
                           1, 
                           &RedWandBulletLarge, 
                           15,
                           15);


    weaponFireCooldownTimer = FIRE_COOLDOWN_TIME;

}

// ObjectStruct* YellowWandBulletCreate(s16 x, s16 y, s16 speedx, s16 speedy, u16 damage, const GGAnimation* animation, s16 rectWidth, s16 rectHeight)

void GreenWandFireLevel1()
{
    YellowWandBulletCreate(playerObject->x + P2V(32), 
                           playerObject->y + P2V(10) + P2V(flyingOffsetY), 
                           BULLET_SPEED >> 1,
                           BULLET_SPEED,
                           1, 
                           &GreenWandBulletSmall, 
                           8,
                           8);

    YellowWandBulletCreate(playerObject->x + P2V(32), 
        playerObject->y + P2V(10) + P2V(flyingOffsetY), 
        BULLET_SPEED >> 1,
        -BULLET_SPEED,
        1, 
        &GreenWandBulletSmall, 
        8,
        8);

    weaponFireCooldownTimer = FIRE_COOLDOWN_TIME;
}

void GreenWandFireLevel2()
{
    YellowWandBulletCreate(playerObject->x + P2V(28), 
        playerObject->y + P2V(10) + P2V(flyingOffsetY), 
        BULLET_SPEED >> 1,
        BULLET_SPEED,
        2, 
        &GreenWandBulletMedium, 
        8,
        8);

    YellowWandBulletCreate(playerObject->x + P2V(28), 
        playerObject->y + P2V(10) + P2V(flyingOffsetY), 
        BULLET_SPEED >> 1,
        -BULLET_SPEED,
        2, 
        &GreenWandBulletMedium, 
        8,
        8);

    weaponFireCooldownTimer = FIRE_COOLDOWN_TIME;
}

void GreenWandFireLevel3()
{
    YellowWandBulletCreate(playerObject->x + P2V(28), 
        playerObject->y + P2V(10) + P2V(flyingOffsetY), 
        BULLET_SPEED >> 1,
        BULLET_SPEED,
        2, 
        &GreenWandBulletMedium, 
        8,
        8);

    YellowWandBulletCreate(playerObject->x + P2V(28), 
        playerObject->y + P2V(10) + P2V(flyingOffsetY), 
        BULLET_SPEED >> 1,
        -BULLET_SPEED,
        2, 
        &GreenWandBulletMedium, 
        8,
        8);

    YellowWandBulletCreate(playerObject->x + P2V(28), 
        playerObject->y + P2V(10) + P2V(flyingOffsetY), 
        BULLET_SPEED,
        BULLET_SPEED,
        2, 
        &GreenWandBulletMedium, 
        8,
        8);

    YellowWandBulletCreate(playerObject->x + P2V(28), 
        playerObject->y + P2V(10) + P2V(flyingOffsetY), 
        BULLET_SPEED,
        -BULLET_SPEED,
        2, 
        &GreenWandBulletMedium, 
        8,
        8);

    weaponFireCooldownTimer = FIRE_COOLDOWN_TIME;
}

weaponFireFunction weaponFireFunctions[NUM_WEAPONS][WEAPON_LEVEL_MAX] = 
{
    {
        YellowWandFireLevel1,
        YellowWandFireLevel2,
        YellowWandFireLevel3,
    },
    {
        RedWandFireLevel1,
        RedWandFireLevel2,
        RedWandFireLevel3,
    },
    {
        GreenWandFireLevel1,
        GreenWandFireLevel2,
        GreenWandFireLevel3,
    }
};

u16 weaponFireCooldownTimer = 0;

void WeaponManager_Init()
{
    weaponFireCooldownTimer = 0;

    memset(weaponLevel, 0, sizeof(weaponLevel));
    memset(numStars, 0, sizeof(numStars));

    weaponPalettes[0] = weapon001PaletteSprite.pal;
    weaponPalettes[1] = weapon002PaletteSprite.pal;
    weaponPalettes[2] = weapon003PaletteSprite.pal;
    weaponPalettes[3] = weapon002PaletteSprite.pal;
}

void WeaponManager_Update()
{
    if (weaponFireCooldownTimer != 0)
    {
        weaponFireCooldownTimer--;
    }
}

extern u16 oldStars;

void WeaponManager_NextWeapon()
{
    currentWeapon++;

    if (currentWeapon > NUM_WEAPONS - 1)
    {
        currentWeapon = 0;
    }

    oldStars = 101;

    // change font color
    // change weapon icon
}

void WeaponManager_UpdateVDP()
{
    if (oldWeapon != currentWeapon)
    {
        VDP_setPalette(PAL1, weaponPalettes[currentWeapon]);

        oldWeapon = currentWeapon;
    }
}

void WeaponManager_SetWeapon(u16 weapon)
{
    currentWeapon = weapon;
}

void WeaponManager_SetWeaponLevel(u16 level)
{
    weaponLevel[currentWeapon] = level;

    if (weaponLevel[currentWeapon] >= WEAPON_LEVEL_MAX)
    {
        weaponLevel[currentWeapon] = WEAPON_LEVEL_MAX - 1;
    }
}

void WeaponManager_UpgradeWeapon(u16 weapon)
{
    weaponLevel[weapon]++;

    if (weaponLevel[weapon] >= WEAPON_LEVEL_MAX)
    {
        weaponLevel[weapon] = WEAPON_LEVEL_MAX - 1;
    }
}

void WeaponManager_Fire()
{
    if (weaponFireCooldownTimer < (FIRE_COOLDOWN_TIME - 5))
    {
        weaponFireFunctions[currentWeapon][weaponLevel[currentWeapon]]();
    }
}

void WeaponManager_Reset()
{

}

void WeaponManager_AddStars(u16 stars)
{
    numStars[currentWeapon] += 5;

    if (numStars[currentWeapon] > 100)
    {
        numStars[currentWeapon] = 100;
    }

    u16 currentLevel = weaponLevel[currentWeapon];

    WeaponManager_SetWeaponLevel((numStars[currentWeapon] / 25));
}

void WeaponManager_RemoveStars(u16 stars)
{
    if (numStars[currentWeapon] > stars)
    {
        numStars[currentWeapon] -= stars;
    }
    else
    {
        numStars[currentWeapon] = 0;
    }

    WeaponManager_SetWeaponLevel((numStars[currentWeapon] / 25));

}

