#ifndef WEAPON_MANAGER_INCLUDE
#define WEAPON_MANAGER_INCLUDE

#include <genesis.h>

#define FIRE_COOLDOWN_TIME 20

#define WEAPON_SHOT     0
#define WEAPON_SPREAD   1
#define WEAPON_NEEDLE   2
#define NUM_WEAPONS     3

extern u16 weaponFireCooldownTimer;
extern u16 currentWeapon;
extern u16 numStars[NUM_WEAPONS];
extern const u16* weaponPalettes[4];

void WeaponManager_Init();
void WeaponManager_Update();
void WeaponManager_UpdateVDP();

void WeaponManager_SetWeapon(u16 weapon);
void WeaponManager_SetWeaponLevel(u16 level);
void WeaponManager_UpgradeWeapon(u16 weapon);
void WeaponManager_Fire();
void WeaponManager_Reset();
void WeaponManager_NextWeapon();
void WeaponManager_AddStars(u16 stars);
void WeaponManager_RemoveStars(u16 stars);

#endif
