#include "BackgroundTree.h"

#include "ObjectCommon.h"

void BackgroundTreeUpdate(ObjectStruct* object);


#define DEBUG_OBJECTS

ObjectStruct*  BackgroundTreeCreate(s16 x, s16 y, u32* properties, u16 numProperties)
{
    ObjectStruct* object = ObjectManager_CreateObject(TYPE_BACKGROUNDOBJECT,
                                                 BackgroundTreeUpdate, 
                                                 GGAnimation_DrawObjectNoFlip,
                                                 CollisionFunctionStub,
                                                 NULL);

    if (!object)
    {
#ifdef DEBUG_OBJECTS
        KDebug_Alert("BackgroundTree could not be created!");
#endif
        return NULL;
    }

    object->x                           = x;
    object->y                           = y;
    object->speedx                      = -1;
    object->speedy                      = 0;
    object->tileAttribute               = TILE_ATTR_FULL(PAL0, 0, 0, 0, BackgroundTree.vdpInfo->startIndex);
    object->screenx = VIRTUAL_TO_PIXEL(object->x) - foregroundScrollData.scrollx_vdp;
    object->screeny = VIRTUAL_TO_PIXEL(object->y);

    SET_ANIMATION(BackgroundTree);

    return object;
}

void BackgroundTreeUpdate(ObjectStruct* object)
{
    object->screenx += scrollLayer4Speed;

    if (object->screenx + object->animation->width < 0)
    {
        ObjectManager_DestroyObject(object);
    }
}

