#include "Explosion.h"

#include "ObjectCommon.h"

void ExplosionUpdate(ObjectStruct* explosionObject);

ObjectStruct* ExplosionCreate(u16 x, u16 y, const GGAnimation* explosionAnimation)
{
    ObjectStruct* object = ObjectManager_CreateObject(TYPE_EFFECT,
                                                      ExplosionUpdate, 
                                                      GGAnimation_DrawObjectNoFlip,
                                                      CollisionFunctionStub,
                                                      NULL);

    if (!object)
    {
#ifdef DEBUG_OBJECTS
        KDebug_Alert("Explosion could not be created!");
#endif
        return NULL;
    }

    object->x                           = x;
    object->y                           = y;
    object->tileAttribute               = TILE_ATTR_FULL(PAL0, 1, 0, 0, explosionAnimation->vdpInfo->startIndex);

    SET_ANIMATION_POINTER(explosionAnimation);

#ifdef DEBUG_OBJECTS
    KDebug_Alert("ExplosionCreate");
#endif

    return object;
}

void ExplosionUpdate(ObjectStruct* object)
{
    UPDATE_ANIMATION_FRAME_NOLOOP_DIE;
    UPDATE_SCREEN_POSITION;
}

