#ifndef OBJECT_COMMON_INCLUDE_H
#define OBJECT_COMMON_INCLUDE_H

#include <KDebug.h>
#include <vdp_pal.h>
#include <vdp_spr.h>
#include <vdp_tile.h>

#include "..\GGAnimationDraw.h"
#include "..\Collisions.h"
#include "..\Debug.h"
#include "..\EnemyTypes.h"
#include "..\exported\ExportedGenResSprites.h"
#include "..\exported\ExportedGGAnimations.h"
#include "..\FunctionStubs.h"
#include "..\generated\AllObjects.h"
#include "..\generated\DebugSettings.h"
#include "..\LevelManager.h"
#include "..\MathUtils.h"
#include "..\ObjectManager.h"
#include "..\PlayerManager.h"
#include "..\ScrollManager.h"
#include "..\VDPInfo.h"
#include "..\VDP_Extra.h"
#include "..\path.h"

#define UPDATE_SCREEN_POSITION \
    object->screenx = VIRTUAL_TO_PIXEL(object->x) - foregroundScrollData.scrollx_vdp;\
    object->screeny = VIRTUAL_TO_PIXEL(object->y) - foregroundScrollData.scrolly_vdp

#define SET_RECT_VIRTUAL(left, right, top, bottom) \
    object->rectLeft                = left;\
    object->rectRight               = right;\
    object->rectTop                 = top;\
    object->rectBottom              = bottom

#define SET_RECT_PIXEL_OBJECT(object, left, right, top, bottom) \
    object->rectLeft                = PIXEL_TO_VIRTUAL(left);\
    object->rectRight               = PIXEL_TO_VIRTUAL(right);\
    object->rectTop                 = PIXEL_TO_VIRTUAL(top);\
    object->rectBottom              = PIXEL_TO_VIRTUAL(bottom)

#define SET_RECT_PIXEL(left, right, top, bottom) \
    object->rectLeft                = PIXEL_TO_VIRTUAL(left);\
    object->rectRight               = PIXEL_TO_VIRTUAL(right);\
    object->rectTop                 = PIXEL_TO_VIRTUAL(top);\
    object->rectBottom              = PIXEL_TO_VIRTUAL(bottom)


#define SET_ANIMATION(anim) \
    object->animation               = &anim;\
    object->animationFrameCounter   = 0;\
    object->currentAnimationFrame   = *(anim.frames)

#define SET_ANIMATION_POINTER(anim)\
    object->animation               = anim;\
    object->animationFrameCounter   = 0;\
    object->currentAnimationFrame   = *(anim->frames)

#define UPDATE_ANIMATION_FRAME_LOOP \
    if (object->animationFrameCounter > object->currentAnimationFrame->frameDelayTime)\
    {\
        object->currentAnimationFrame = object->currentAnimationFrame->nextFrame;\
        object->animationFrameCounter = 0;\
    }\
    object->animationFrameCounter++

#define UPDATE_ANIMATION_FRAME_NOLOOP \
    if (object->animationFrameCounter > object->currentAnimationFrame->frameDelayTime)\
    {\
        if (object->currentAnimationFrame->nextFrame)\
        {\
            object->currentAnimationFrame = object->currentAnimationFrame->nextFrame;\
            object->animationFrameCounter = 0;\
        }\
    }\
    object->animationFrameCounter++

#define UPDATE_ANIMATION_FRAME_NOLOOP_DIE\
    if (object->animationFrameCounter > object->currentAnimationFrame->frameDelayTime)\
    {\
        object->currentAnimationFrame = object->currentAnimationFrame->nextFrame;\
        object->animationFrameCounter = 0;\
        if (!object->currentAnimationFrame->nextFrame)\
        {\
            ObjectManager_DestroyObject(object);\
            return;\
        }\
    }\
    object->animationFrameCounter++

#endif

