#include "WandGrabber.h"

#include "ObjectCommon.h"


void WandGrabberUpdate(ObjectStruct* object);
void WandGrabGrabbed(ObjectStruct* grabber, ObjectStruct* object);

s16 const animatedRect[] = //7 frames
{
    0, 0,       // 1
    12, 20,     // 2
    24, 36,     // 3
    36, 48,     // 4
    24, 36,     // 5
    12, 20,     // 6
    0, 0,       // 7
};

u16 const skipFrame[] =
{
    6, // 1
    5, // 2
    4, // 3
    3, // 4
    4, // 5 
    5, // 6
    6, // 7
};

extern const GGFrame* const WandGrabFrames[7];

ObjectStruct* WandGrabber()
{
    ObjectStruct* object = ObjectManager_CreateObject(TYPE_GRABBER,
                                                      WandGrabberUpdate, 
                                                      GGAnimation_DrawObjectNoFlip,
                                                      NULL,
                                                      WandGrabGrabbed);

    if (!object)
    {
        return NULL;
    }

    object->x                       = playerObject->x + P2V(36);
    object->y                       = playerObject->y + P2V(2);
    object->speedx                  = 0;
    object->speedy                  = 0;
    object->tileAttribute           = TILE_ATTR_FULL(PAL0, 1, 0, 0, WandGrab.vdpInfo->startIndex);
    object->lifetime = 0;

    //SET_RECT_PIXEL(5, 18, 6, 21);
    SET_ANIMATION(WandGrab);

    return object;
}

void WandGrabberUpdate(ObjectStruct* object)
{
    object->x = playerObject->x + P2V(28);
    object->y = playerObject->y + P2V(2);

    s16 const* position = animatedRect + ((object->lifetime >> 1) << 1);

    SET_RECT_PIXEL(*(position), *(position + 1), 0, 16);

    if (grabbedObject)
    {
        grabbedObject->x = object->x + P2V(*(position));
        grabbedObject->y = playerObject->y;

        if (object->lifetime == 12)
        {
            grabbedObject->updateFunction = ThrowObjectUpdate;
        }
    }

    UPDATE_ANIMATION_FRAME_NOLOOP_DIE;
    UPDATE_SCREEN_POSITION;

    object->screeny += flyingOffsetY;
}

void WandGrabGrabbed(ObjectStruct* grabber, ObjectStruct* object)
{
    u16 frameNumber = *(skipFrame + (grabber->lifetime >> 1));

    grabber->currentAnimationFrame = *(WandGrabFrames + frameNumber);
    grabber->animationFrameCounter = 0;
    grabber->lifetime = frameNumber << 1;

}


