# helper script that generates .h and .c files from graphics gale files

import sys
import os
import time
import xml.etree.ElementTree as ET

maplist = []
tilesets = set()
tilesetbitmaps = set()

tilesetsrc_timestamp = None

#destination_folder = "gamedata\\tilesets"
#destination_path = os.path.realpath('.') + "\\" + destination_folder

from glob import glob
print "************** Checking to update tilesets.rc file **************"
filenames = glob('..\gamedata\GGAnimations\*.gal')

def getmaplist():
    global maplist
    maplist = glob('..\gamedata\maps\*.gmx')

def gettilesetfilename(tilesetnode):
    global tilesetfilename
    sourcefilename = tilesetnode.get('source')

def gettilesets():
    for map in maplist:
        tree = ET.parse(map)
        root = tree.getroot()
        tilesetnode = root.find('tileset')
        tilesetfilename = '..\\gamedata\\tilesets\\' + tilesetnode.get('source')
        tilesets.add(tilesetfilename)

def gettilesetbitmaps():
    for tileset in tilesets:
        tree = ET.parse(tileset)
        root = tree.getroot()
        imagenode = root.find('image')
        tilesetbitmapfilename = '..\\gamedata\\tilesets\\' + imagenode.get('source')
        tilesetbitmaps.add(tilesetbitmapfilename)

def gettilesrctimestamp():
    global tilesetsrc_timestamp
    tilesetsrc_timestamp = os.path.getmtime('..\\gamedata\\tilesets\\tilesets.rc')


def maps_are_newer():
    global tilesetsrc_timestamp
    global maplist
    for map in maplist:
        maptimestamp = os.path.getmtime(map)
        if maptimestamp > tilesetsrc_timestamp:
            return True
    return False

def tilesets_are_newer():
    global tilesetsrc_timestamp
    global tilesets
    
    for tileset in tilesets:
        tilesettimestamp = os.path.getmtime(tileset)
        if tilesettimestamp > tilesetsrc_timestamp:
            return True
    return False

def tilesetbitmaps_are_newer():
    global tilesetsrc_timestamp
    global tilesetbitmaps
    
    for tilesetbitmap in tilesetbitmaps:
        tilesetbitmaptimestamp = os.path.getmtime(tilesetbitmap)
        if tilesetbitmaptimestamp > tilesetsrc_timestamp:
            return True
    return False

def regeneratetilesetrc():
    print "************** Regenerating tilesets.rc file **************"
    tilesetsrc = open("..\\gamedata\\tilesets\\tilesets.rc", "w")

    for tilesetbitmap in tilesetbitmaps:
        bitmapfilename = tilesetbitmap.rsplit('\\', 1)[1]
        tilesetname = bitmapfilename.split('.')[0]
        tilesetsrc.write('SPRITE ' + tilesetname + 'Sprite "gamedata\\tilesets\\' + bitmapfilename + '" 8 8\n')
    tilesetsrc.write('\n\n')
    tilesetsrc.close()

regenerate_tilesetrc = True

getmaplist()
gettilesets()
gettilesetbitmaps()

if os.path.exists('..\\gamedata\\tilesets\\tilesets.rc'):
    gettilesrctimestamp()

    if not maps_are_newer():
        if not tilesets_are_newer():
            if not tilesetbitmaps_are_newer():
                regenerate_tilesetrc = False

if regenerate_tilesetrc:
    regeneratetilesetrc()
else:
    print "************** No update to tilesets.rc file required **************"

