#generates the table for distances and angles

import math

screen_width_in_tiles = 40
screen_height_in_tiles = 28
area_width_in_screens = 1
area_height_in_screens = 1

total_width_in_tiles = screen_width_in_tiles * area_width_in_screens
total_height_in_tiles = screen_height_in_tiles * area_height_in_screens
total_size = total_width_in_tiles * total_height_in_tiles

number_of_angles = 32.0
speed = 3.0
degrees = 360.0 / number_of_angles

tile_width = 8
tile_height = 8
origin_x = 0
origin_y = 0
destination_x = 0
destination_y = 0

with open('xy_angles.c', 'w') as f:
    f.write("u16 const xy_angles" + str(screen_width_in_tiles) + "x" + str(screen_height_in_tiles) + "speed" + str(int(speed)) + "[" + str(total_size) + "] =\n")
    f.write("{\n")

    for y in range(int(total_height_in_tiles)):
        f.write('    ')
        destination_y = float(y * tile_height)
        for x in range(int(total_width_in_tiles)):
            destination_x = float(x * tile_width)
            distance = math.sqrt( (destination_x)**2 + (destination_y)**2 )

            angle_rad = math.atan2(destination_y, destination_x)

            angle_x = int(round(math.cos(angle_rad) * speed))
            angle_y = int(round(math.sin(angle_rad) * speed))

            f.write('(' + str(angle_x) + ' << 8) |' + str(angle_y) + ', ')

            #writevalue = (angle_x << 8) | angle_y
            #f.write(str(writevalue) + ', ')

        f.write('\n')
    f.write("};\n\n")

    f.write('/*\n')

f.close()

